﻿Imports System.Web
Imports System.Net
Imports System.Linq
Imports System.Xml
Module Module1

    Sub Main()
        dumpxml()
        processxml()

    End Sub
    Private Sub processxml()
        Dim index As New Dictionary(Of String, List(Of Int32))
        Dim errorlog = IO.File.CreateText("errorlog.txt")
        Dim partlist As XElement = <partlist></partlist>
        Dim resultxml As XElement = <update date=<%= Now.ToString("yyyy-MM-dd") %>></update>
        Dim count = 0
        Dim filelist = IO.Directory.EnumerateFiles("partsxml")
        For Each i In IO.Directory.EnumerateFiles("partsxml")
            Dim tempdoc As XDocument
            Try
                Dim strr = New IO.StreamReader(i, Text.Encoding.UTF8)
                tempdoc = XDocument.Parse(strr.ReadToEnd)
            Catch ex As Exception
                errorlog.WriteLine(String.Format("{0}   exception message:{1}{2}xml:{3}", Now.ToShortTimeString, ex.ToString, vbCrLf, i.ToString))
            End Try

            count += 1
            Console.WriteLine("Processing Total:" & filelist.Count & "   Current:" & count & "    BioBrick:" & tempdoc...<part_name>.Value)
            Dim wordlist = getworldlist(tempdoc...<part_short_desc>.Value.ToLower)
            For Each j In wordlist
                Dim temp As Int32
                If Integer.TryParse(j, temp) = False Then
                    If index.ContainsKey(j) = False Then
                        index.Add(j, New List(Of Int32))
                    End If
                    index(j).Add(Val(tempdoc...<part_id>.Value))
                End If
            Next
            Dim rate As Int16
            rate = 0
            If tempdoc...<part_status>.Value = "Available" Then
                rate += 1

            End If
            If tempdoc...<part_result>.Value = "Works" Then
                rate += 1
            End If
            partlist.Add(<part><id><%= tempdoc...<part_id>.Value %></id><name><%= tempdoc...<part_name>.Value %></name><description><%= tempdoc...<part_short_desc>.Value %></description><type><%= tempdoc...<part_type>.Value %></type><rate><%= rate %></rate><length><%= tempdoc...<seq_data>.Value.Length %></length></part>)
        Next
        For Each i In index
            If i.Key = "" Then
                Continue For
            End If
            Dim mutablestring As New Text.StringBuilder
            For Each j In i.Value
                mutablestring.Append(j & ",")
            Next

            resultxml.Add(<index key=<%= i.Key %>><%= mutablestring.ToString.TrimEnd(",") %></index>)
        Next
        Dim xmlfile = IO.File.CreateText("partsxml\index.xml")
        xmlfile.Write(resultxml.ToString)
        xmlfile.Close()
        xmlfile = IO.File.CreateText("partxml\partlist.xml")
        xmlfile.Write(partlist.ToString)
        xmlfile.Close()
        Console.WriteLine("Succeed")
        Console.ReadKey()
    End Sub

    Private Function getworldlist(ByRef description As String) As List(Of String)
       
        Dim replacesymbol As String = ", . / ; ' < > ? : "" [ ] { } _ - + = * ( )"

        Dim replacelist() = replacesymbol.Split(" ")
        For Each i In replacelist
            description = description.Replace(i, " ")
        Next
        Dim wordlist = New List(Of String)(description.Split(" "))
        Dim ignorewords As String = "bba the a this e that i you me he then when it are am is she there where at on in 1 2 3 4 5 6 7 8 9 0 q w e r t y u i o p a s d f g h j k l z x c v b n m"
        Dim ignorelist() = ignorewords.Split(" ")
        For Each i In ignorelist
            wordlist.Remove(i)
        Next
        wordlist.Distinct()
        wordlist.Remove("")
        Return wordlist
    End Function
    Private Sub dumpxml()
        Dim therequest As HttpWebRequest
        therequest = HttpWebRequest.Create("http://partsregistry.org/das/parts/entry_points")
        Dim filestr = IO.File.Create("allparts.xml")
        IO.Directory.CreateDirectory("partsxml")
        Dim response As HttpWebResponse = therequest.GetResponse
        Dim strreader As New IO.StreamReader(response.GetResponseStream())

        response.GetResponseStream().CopyTo(filestr)
        filestr.Flush()
        filestr.Close()
        Dim allpartsdoc As XDocument
        allpartsdoc = XDocument.Load(IO.File.OpenRead("allparts.xml"))
        Dim partslist = From i In allpartsdoc...<SEGMENT>

        Console.WriteLine("Total:" & partslist.Count)

        Console.ReadKey()
        Dim count = 0
        Dim all = partslist.Count
        For Each i As XElement In partslist
            count += 1
            Console.WriteLine("Downloading Total:" & all & "   Current:" & count & "    BioBrick:" & i.Value)
            therequest = HttpWebRequest.Create("http://partsregistry.org/cgi/xml/part.cgi?part=" & i.Value)
            response = therequest.GetResponse
            filestr = IO.File.Create("partsxml\" & i.Value & ".xml")
            response.GetResponseStream().CopyTo(filestr)
            filestr.Flush()
            filestr.Close()
            ' Threading.Thread.Sleep(1000)
        Next
    End Sub
End Module
